/*
* HelpServ provides help - Alek 
* By: Alek - Abducted.us Network - www.abducted.us
* Commands:
* Changelog:
* 0.0.1A
* Works
*/
#include "module.h"

/* Basic defines */
#define AUTHOR "Alek"
#define VERSION "0.0.1A"

/* DB Name in services dir you would like info saved in */
#define DB_NAME "helpserv.db"
/* Time it updates */
#define DB_UPDATE "5m"

/* Quit message handling */
int my_privmsg(char *source, int ac, char **msg);

/* RDB function defs */
int mLoadData(void);
int mSaveData(int argc, char **argv);

/* Help structure */
typedef struct helpinfo_ HelpInfo;

struct helpinfo_ {
	HelpInfo *next, *prev;
	char *request;
	char *help;
	int used;
};

#define HASH(request)	((tolower((request)[0])&31)<<5 | (tolower((request)[1])&31))

HelpInfo *hilists[1024];

HelpInfo *findhelp(char *request){
    HelpInfo *hi;
    
    for (hi = hilists[HASH(request)]; hi; hi = hi->next) {
        if (request){
	if (!stricmp( hi->request, request))
            	return hi;
	}
    }

    return NULL;
}

/* Insert into struct */
HelpInfo *insert_help(char *request, char *help){
        HelpInfo *hi;
	int index;
        hi = scalloc(1, sizeof(HelpInfo));
        hi->request = sstrdup(request);
        hi->help = sstrdup(help);
        hi->used = 0;
        
        index = HASH(hi->request);

        hi->prev = NULL;
        hi->next = hilists[index];
    if (hi->next)
        hi->next->prev = hi;
        hilists[index] = hi;
        
        return hi;
}

/* Adding helpstrs */
int hs_add(User *u);

int AnopeInit(void){
    Message *msg;
    Command *c;
    
    msg = createMessage("PRIVMSG", my_privmsg);
    moduleAddMessage(msg, MOD_HEAD);
    c = createCommand("ADD", hs_add, is_services_root, -1, -1, -1, -1, -1);
    moduleAddCommand(HELPSERV, c, MOD_HEAD);
    alog("hs_autohelp.so: Initialized, loading data: %d", mLoadData());
    
    moduleAddCallback("save me",time(NULL)+dotime(DB_UPDATE),mSaveData,0,NULL);

    return MOD_CONT;
}

void AnopeFini(void){
    mSaveData(NULL, NULL);
    alog("hs_autohelp.so: Unloading");
}

int hs_add(User *u){
	char *request, *help;
        char *buffer = moduleGetLastBuffer();
	request = myStrGetToken(buffer, ':', 0);
	help = myStrGetToken(buffer, ':', 1);
	if (request && help){
		if (!findhelp(request)){
			notice(s_HelpServ, u->nick, "Added %s Answer %s", request, help);
			insert_help(request, help);
		} else {
			notice(s_HelpServ, u->nick, "Already exists");
		}
	}
	else
	notice(s_HelpServ, u->nick, "Syntax: ADD Question : Answer");
	return MOD_CONT;
}

int my_privmsg(char *source, int ac, char **msg){
    HelpInfo *hi;
    char *search;
    int found = 0, i = 0, j = 0;
    if (stricmp(msg[0], "#help"))
        return MOD_CONT;

    for (j = 0; j < 1024; j++){	
    for (hi = hilists[j]; hi; hi = hi->next){
	while ((search = myStrGetToken(hi->request, ' ', i))){
		if (stristr(msg[1], search)){
			found = 1;
			i++;
		} else {
			found = 0;
			i = 0;
			break;
		}
	}
	if (found){
        	privmsg(s_HelpServ, "#help", "Auto Help: %s", hi->help);
		hi->used = hi->used + 1;
		return MOD_CONT;
	}
    }
    }

    return MOD_CONT;
}

int mSaveData(int argc, char **argv) {
    HelpInfo *hi = NULL;
	int i = 0;
	int ret = 0;
	FILE *out;
	if ((out = fopen(DB_NAME, "w")) == NULL) {
		alog("hs_autohelp.so: HELP! I cant open my data file.");
		ret = 1;
	} else {		
		for(i = 0; i<1024;i++) {
			for(hi = hilists[i]; hi; hi = hi->next ) {	
    				fprintf(out,"%s|%s|%d|\n",hi->request, hi->help, hi->used);
			}
		}
		
	}
		fclose(out);
	moduleAddCallback("save me",time(NULL)+dotime(DB_UPDATE),mSaveData,0,NULL);
	return ret;
}

/* Load Data -> Alek */
int mLoadData(void) {
	int ret = 0;
	FILE *in;
	
	char *request = NULL, *help = NULL, *used = NULL;
   	HelpInfo *hi = NULL;
	
	char buffer[2000]; /* will _never_ be this big thanks to the 512 limit of a message */

	if ((in = fopen(DB_NAME, "r")) == NULL) {
		alog("hs_autohelp.so: HELP! I cant open my data file. (it might not exist, this isnt fatal)");
		ret = 1;
	} else {	
		while (!feof(in)) {
			fgets(buffer,1500,in);
			request = myStrGetToken(buffer, '|',0);
            		help = myStrGetToken(buffer, '|', 1);
           		used = myStrGetToken(buffer, '|', 2);
            		
			if(request) {
               		if (!(hi = findhelp(request)))
                     	  hi = insert_help(request, help);
			if (used)
			  hi->used = atoi(used);
			}
      		}
	}
	return ret;
}
